indexing

	description: "Child_state, has some state for parent..."

	author:     "Berend de Boer <berend@pobox.com>"
	copyright:  "Copyright (c) 2001 by Berend de Boer, see forum.txt"
	date:       "$Date: $"
	revision:   "$Revision: $"


class

	CHILD_STATE


creation

	make


feature -- creation

	make (a_child: CHILD_DEFINITION) is
		require
			child_not_void: a_child /= Void
		do
			child := a_child
		end


feature -- State

	child: CHILD_DEFINITION


feature {DEFINED_ELEMENT, CHILD_DEFINITION} -- Child specific state

	cursor: DS_LINEAR_CURSOR [CHILD_DEFINITION]


feature {CHILD_DEFINITION_SEQ} -- Specific state change

	set_cursor (a_cursor: DS_LINEAR_CURSOR [CHILD_DEFINITION]) is
		require
			valid_cursor: a_cursor /= Void
		do
			cursor := a_cursor
		end


feature {CHILD_DEFINITION_OCCURRENCE} -- Specific state

	occurrences: INTEGER

	advance_occurrences is
		do
			occurrences := occurrences + 1
		end


invariant

	occurrences_not_negative: occurrences >= 0
	child_not_void: child /= Void

end
