indexing

	description: "Describes a single <!ELEMENT> definition."

	author:     "Berend de Boer <berend@pobox.com>"
	copyright:  "Copyright (c) 2001 by Berend de Boer, see forum.txt"
	date:       "$Date: $"
	revision:   "$Revision: $"


deferred class

	DEFINED_ELEMENT


feature -- Initialization

	make (a_name: STRING) is
		require
			name_not_empty: a_name /= Void and then not a_name.is_empty
		do
			name := a_name
		end


feature -- State

	name: STRING

	attributes: DS_LIST [DEFINED_ATTRIBUTE]


feature -- Output

	content_specification: STRING is
		deferred
		ensure
			has_result: Result /= Void
		end

	generate_child_definition (xml: EPX_XML_WRITER) is
		do
			-- default, do nothing
		end


invariant

	name_not_empty: name /= Void and then not name.is_empty

end
