indexing
   
   description: "Wraps G_SCIENTIFIC_FORMAT so it doesn't overload your namespace"

   usage: "Inherit from this class."
   
   
class 
   
   G_FORMAT

   
feature -- Print group of argruments using specified format

--     printf (format: STRING; para: ARRAY [ ANY ]) is
--           -- formats list of items and prints them
--        do
--           assert_scientific_formatter_created
--           my_scientific_formatter.printf (format, para)
--        end
   
   sprintf (format: STRING; para: ARRAY [ ANY ]): STRING is
         -- formats list of items into string
         -- errors checked only in precondition
      do
         assert_scientific_formatter_created
         Result := my_scientific_formatter.sprintf (format, para)
      end

--     to_string (format: STRING; para: ANY): STRING is
--           -- format single argument to string
--        do
--           assert_scientific_formatter_created
--           Result := my_scientific_formatter.to_string (format, para)
--        end

      
feature {NONE}
   
   my_scientific_formatter: G_SCIENTIFIC_FORMAT

   assert_scientific_formatter_created is
      do
         if my_scientific_formatter = Void then
            !! my_scientific_formatter.make
         end
      ensure
         is_created: my_scientific_formatter /= Void
      end

end
